clear all; clc;

addpath('fieldII\matlab');
addpath('other_code');

% load data (3 poses)
load('C:\Users\Kai_Zhang\Desktop\0504\RF_96.mat');
RFframe_o = RFframe;
load('C:\Users\Kai_Zhang\Desktop\0504\RF_144.mat');
RFframe_plus = RFframe;
load('C:\Users\Kai_Zhang\Desktop\0504\RF_48.mat');
RFframe_minus = RFframe;

% format data
line = 32;
for i = 1:line
    newRF(:,i) =  RFframe_o(:,i+48,i+48);
end

for j = 1:2000
    plainRF(round(j/2),:) = newRF(j,:);
end

for i = 1: line
    RFframe_o2(:,i,:) = RFframe_o(:,i+48,:);
end

% SA reconstruction
sum1 = zeros(2000,line);
for j = 1:line
    RF = RFframe_o2(:,:,j+48);
    out = sa_reconstruction(RF, j, 0.3);
    sum1 = sum1 + out;
end

bf_image = sum1(:,:);
bf_image = abs(hilbert(bf_image)); % Envelope detection
bf_image = bf_image / max(max(bf_image));
y = [1 size(bf_image,1)]*0.5 / 40e6 * 1540 * 1e3;
x = [1 size(bf_image,2)] / 128 * 38.4;

figure;
bf_image_p = 20*log10(bf_image + 0.001);
for i = 1:line
    for j = 1:2000
        if bf_image_p(j,i) < -20
            bf_image_p(j,i) = -20;
        end
    end
end
subplot(121);
imagesc(x, y, bf_image_p);
colormap(gray);
title(['Single pose']);
axis image;
xlabel('Distance (mm)')
ylabel('Distance (mm)')

preBeamSA = zeros(2000,128,128);
preBeamSA2 = zeros(2000,line,128);

shift = 17;
lat = 15;
line = 32;

for j = 1:128
    for i = 1:64
        if(j+lat<128)
            preBeamSA(1:2000-shift,i,j) = RFframe_plus(1+shift:2000,i+lat,j+lat);
        end
    end
end

for j = 1:128
    for i = 65:128
        if(j-16>1)
            preBeamSA(:,i,j) = RFframe_minus(:,i-16,j-16);
        end
    end
end

for i = 1:line
    preBeamSA2(:,i,:) = preBeamSA(:,i+48,:);
end

sum2 = zeros(2000,line);
for j = 1:line
    RF = preBeamSA2(:,:,j+48);
    out = sa_reconstruction(RF, j, 0.3);
    sum2 = sum2 + out;
end

bf_image2 = sum2;
bf_image2 = abs(hilbert(bf_image2)); % Envelope detection
bf_image2 = bf_image2 / max(max(bf_image2));

y = [1 size(bf_image2,1)]*0.5 / 40e6 * 1540 * 1e3;
x = [1 size(bf_image2,2)] / 128 * 38.4;

bf_image_p2 = 20*log10(bf_image2 + 0.001);
for i = 1:line
    for j = 1:2000
        if bf_image_p2(j,i) < -20
            bf_image_p2(j,i) = -20;
        end
    end
end

subplot(122);
imagesc(x, y, bf_image_p2);
colormap(gray);
title(['Two poses']);
axis image;
xlabel('Distance (mm)')
ylabel('Distance (mm)')