% modified 10/22/98, to correct axis label on psf krn

figure(handles.plot_figure);
colormap(gray);

excitationPulsePlot = excitationPulse;

if flags.non_delta == 0
  excitationPulsePlot=[zeros(1,500) 1 zeros(1,500)];
  timeExcite=0:1/samplingFrequency:(size(excitationPulsePlot,2)-1)/samplingFrequency;
end;

%  the switching is different based on the plotmenu possibilities

if (flags.calc_hp == 0) & (flags.calc_hhp == 0)
  switch(get(handles.plot_type,'Value'))
    case 3
      plot(1e6*t,impulseResponse)
      title('Simulated impulse response of a single element')
      xlabel('time, microseconds')
      ylabel('normalized impulse response')
    case 4
      plot(1e6*timeExcite,excitationPulsePlot)
      title('Excitation pulse')
      xlabel('time, microseconds')
      ylabel('excitation pulse')
  end
end

if (flags.calc_hp == 1) & (flags.calc_hhp == 0)
  switch(get(handles.plot_type,'Value'))
    case 3
      plot(1e6*t,impulseResponse)
      title('Simulated impulse response of a single element')
      xlabel('time, microseconds')
      ylabel('normalized impulse response')
    case 4
      plot(1e6*timeExcite,excitationPulsePlot)
      title('Excitation pulse')
      xlabel('time, microseconds')
      ylabel('excitation pulse')
    case 5
      imagesc(lateralPosition,distaftertx,pressure)
      %imagesc(lateralPosition,1e6*timeaftertx,pressure)
      xlabel('lateral position, mm')
      %ylabel('time after transmit, microseconds')
      ylabel('axial distance, mm')
      title('TX Pressure Field in the Focal Plane')
    case 6 
      [val index]=max(max(pressure));
      %centercol=ceil(size(pressure,2)/2);
      plot(1e6*timeaftertx,pressure(:,index)/max(pressure(:,index)));
      xlabel('time after transmit, microseconds')
      ylabel('normalized pressure')
      title('TX Pressure vs. Time, at Lateral Location of Peak Pressure')
    case 7
      MaxVal=max(pressure);
      plot(lateralPosition,20*log10(MaxVal/max(MaxVal)))
      xlabel('lateral position, mm')
      ylabel('Maximum Pressure Value at each Lateral Position (dB re maximum)')
      title('TX Lateral Beam Plot')
  end
end

if (flags.calc_hp == 0) & (flags.calc_hhp == 1)
  switch(get(handles.plot_type,'Value'))
    case 3
      plot(t,impulseResponse)
      title('Simulated impulse response of a single element')
      xlabel('time, seconds')
      ylabel('normalized impulse response')
    case 4
      plot(1e6*timeExcite,excitationPulsePlot)
      title('Excitation pulse')
      xlabel('time, microseconds')
      ylabel('excitation pulse')
    case 5
     % imagesc(lateralPosition,1e6*timetxrx,psf)
      imagesc(lateralPosition,disttxrx,psf)
      xlabel('lateral position, mm')
      %ylabel('time after transmit, microseconds');
      ylabel('axial distance mm');
      title('TX/RX Pressure Field in the Focal Plane')
    case 6
      [val index]=max(max(psf));
      plot(1e6*timetxrx,psf(:,index)/max(psf(:,index)));
      xlabel('time after transmit, microseconds')
      ylabel('normalized pressure');
      title('TX/RX Pressure vs. Time, at Lateral Location of Peak Pressure')
    case 7
      MaxValPsf=max(psf);
      plot(lateralPosition,20*log10(MaxValPsf/max(MaxValPsf)))
      xlabel('lateral position, mm')
      ylabel('Maximum Pressure Value at each Lateral Position (dB re maximum)')
      title('TX/RX Lateral Beam Plot')
    case 8
      imagesc(flat,fax,abs(kpsf))
      xlabel('Lateral Spatial Frequency, cycles/mm')
      ylabel('Axial Spatial Frequency, cycles/mm')
      title('K-Space Representation')
    case 9
      [val index]=max(max(abs(kpsf)));
      plot(fax, abs(kpsf(:,index))/max(max(abs(kpsf))));
      xlabel('Axial Spatial Frequency, cycles/mm');
      ylabel('Normalized Magnitude');
      title('Axial Slice through K-Space (taken at location of peak energy)');
    case 10 
      [val i]=max(max(abs(kpsf')));
      plot(flat, abs(kpsf(i,:))/max(max(abs(kpsf))));
      xlabel('Lateral Spatial Frequency, cycles/mm');
      ylabel('Normalized Magnitude');
      title('Lateral Slice through K-Space (taken at location of peak energy)');
    case 11
      imagesc(lateralPosition,disttxrx,envsc);
      xlabel('lateral position, mm')
      ylabel('axial distance, mm');
      title('Detected image, log-compressed')
    case 12
      [val index]=max(max(envsc));
      plot(1e6*timetxrx,envsc(:,index));
      xlabel('time after transmit, microseconds')
      ylabel('log-compressed detected pressure')
      title('Axial slice of Detected, Compressed, and scaled Image, at Location of Peak Pressure');
    case 13
      [val index]=max(max(envsc'));
      plot(lateralPosition,envsc(index,:))
      xlabel('lateral position, mm')
      ylabel('log-compressed detected pressure')
      title('Lateral slice of Detected, Compressed, and scaled Image, at Location of Peak Pressure');
  end
end

if (flags.calc_hp == 1) & (flags.calc_hhp == 1)
  switch(get(handles.plot_type,'Value'))
    case 3
      plot(1e6*t,impulseResponse)
      title('Simulated impulse response of a single element')
      xlabel('time, microseconds')
      ylabel('normalized impulse response')
    case 4
      plot(1e6*timeExcite,excitationPulsePlot)
      title('Excitation pulse')
      xlabel('time, microseconds')
      ylabel('excitation pulse')
    case 5
      %imagesc(lateralPosition,1e6*timeaftertx,pressure)
      imagesc(lateralPosition,distaftertx,pressure)
      xlabel('lateral position, mm')
      %ylabel('time after transmit, microseconds')
      ylabel('axial dist, mm')
      title('Transmitted Pressure Field in the Focal Plane')
    case 6 
      %centercol=ceil(size(pressure,2)/2);
      [val index]=max(max(pressure));
      plot(1e6*timeaftertx,pressure(:,index)/max(pressure(:,index)));
      xlabel('time after transmit, microseconds')
      ylabel('normalized pressure')
      title('TX Pressure vs. Time, at Lateral Location of Peak Pressure')
    case 7
      %BeamPlotIntE=sum(pressure.*pressure);
      %plot(lateralPosition,20*log10(BeamPlotIntE/max(BeamPlotIntE)))
      %ylabel('Integrated Energy (dB re maximum)')
      MaxVal=max(pressure);
      plot(lateralPosition,20*log10(MaxVal/max(MaxVal)))
      xlabel('lateral position, mm')
      ylabel('Maximum Pressure Value at each Lateral Position (dB re maximum)')
      title('TX Lateral Beam Plot')
    case 8
      %imagesc(lateralPosition,1e6*timetxrx,psf)
      imagesc(lateralPosition,disttxrx,psf)
      xlabel('lateral position, mm')
      %ylabel('time after transmit, microseconds');
      ylabel('axial distance mm');
      title('TX/RX Pressure Field in the Focal Plane')
    case 9
%      centercol=ceil(size(psf,2)/2);
      [val index]=max(max(psf));
      plot(1e6*timetxrx,psf(:,index)/max(psf(:,index)));
      xlabel('time after transmit, microseconds')
      ylabel('normalized pressure');
      title('TX/RX Pressure vs. Time, at Lateral Location of Peak Pressure')
    case 10
      %BeamPlotIntE=sum(psf.*psf);
      %plot(lateralPosition,20*log10(BeamPlotIntE/max(BeamPlotIntE)))
      %ylabel('Integrated Energy (dB re maximum)')
      MaxValPsf=max(psf);
      plot(lateralPosition,20*log10(MaxValPsf/max(MaxValPsf)))
      xlabel('lateral position, mm')
      ylabel('Maximum Pressure Value at each Lateral Position (dB re maximum)')
      title('TX/RX Lateral Beam Plot')
    case 11
      imagesc(flat,fax,abs(kpsf))
      xlabel('Lateral Spatial Frequency, cycles/mm')
      ylabel('Axial Spatial Frequency, cycles/mm')
      title('K-Space Representation')
    case 12
      %centercolpsf=ceil(size(kpsf,2)/2);
      [val index]=max(max(abs(kpsf)));
      plot(fax, abs(kpsf(:,index))/max(max(abs(kpsf))));
      xlabel('Axial Spatial Frequency, cycles/mm');
      ylabel('Normalized Magnitude');
      title('Axial Slice through K-Space (taken at location of peak energy)');
    case 13 
      [val i]=max(max(abs(kpsf')));
      plot(flat, abs(kpsf(i,:))/max(max(abs(kpsf))));
      xlabel('Lateral Spatial Frequency, cycles/mm');
      ylabel('Normalized Magnitude');
      title('Lateral Slice through K-Space (taken at location of peak energy)');
    case 14
      imagesc(lateralPosition,disttxrx,envsc);
      xlabel('lateral position, mm')
      ylabel('axial distance, mm');
      title('Detected image, log-compressed')
    case 15
      [val index]=max(max(envsc));
      plot(1e6*timetxrx,envsc(:,index));
      xlabel('time after transmit, microseconds')
      ylabel('log-compressed detected pressure')
      title('Axial slice of Detected, Compressed, and scaled Image, at Location of Peak Pressure');
    case 16
      [val index]=max(max(envsc'));
      plot(lateralPosition,envsc(index,:))
      xlabel('lateral position, mm')
      ylabel('log-compressed detected pressure')
      title('Lateral slice of Detected, Compressed, and scaled Image, at Location of Peak Pressure');
  end
end

set(handles.plot_type,'Value',1);

