function out = sa_reconstruction(preBeamRF, no_ele, pitch)

ns = size(preBeamRF,1);   % number of samples
nl = size(preBeamRF,2);   % number of lines

channelSpacing = pitch; % spacing between lines/channels in the lateral direction in milimeter
sampleSpacing = 1/40e6*1540*1e3; % spacing between samples in photoacoustic imaging
speedSound = 1540000; % mm/s
sampleFreq = 40e6;

postBeamRF = zeros(ns,nl);

m = no_ele;
rm_x = m * channelSpacing;
for i = 1:nl
    rp_x = i * channelSpacing;
    for j = 1:ns
        rp_y = j * sampleSpacing;
        for n = 1:nl
            rn_x = n * channelSpacing;
            rn_rp = sqrt((rn_x - rp_x)^2 + (rp_y)^2);
            rm_rp = sqrt((rm_x - rp_x)^2 + (rp_y)^2);
            delays(j,n) = (abs(rn_rp + rm_rp - (rp_y+rp_y))/ sampleSpacing);
            if j+round(2*delays(j,n)) < ns
                postBeamRF(j,i) = postBeamRF(j,i) + preBeamRF(j+round(2*delays(j,n)),n);
            end
        end
    end
end

out = postBeamRF;

end